/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.PtovtaComissaoDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaComissao;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.LogAuditoriaService;
import com.rjconsultores.ventaboletos.service.PtovtaComissaoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 * 
 * @author Desenvolvimento
 */
@Service("ptovtaComissaoService")
public class PtovtaComissaoServiceImpl implements PtovtaComissaoService {

	private static Logger log = LogManager.getLogger(PtovtaComissaoServiceImpl.class);

	@Autowired
	private PtovtaComissaoDAO ptovtaComissaoDAO;
	@Autowired
	private LogAuditoriaService logAuditoriaService;

	public List<PtovtaComissao> obtenerTodos() {
		return ptovtaComissaoDAO.obtenerTodos();
	}

	public PtovtaComissao obtenerID(Integer id) {
		
		PtovtaComissao ptovtaComissao = ptovtaComissaoDAO.obtenerID(id);
		try {
			ptovtaComissao.clonar();
		} catch (Exception e) {
			log.error(e.getMessage(), e);
		}
		return ptovtaComissao;
	}

	@Transactional
	public PtovtaComissao suscribir(PtovtaComissao entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		ptovtaComissaoDAO.suscribir(entidad);
		logAuditoriaService.auditar(null, entidad, entidad.getEmpresaId() != null ? entidad.getEmpresaId().getEmpresaId() : null);
		
		return entidad;


	}

	@Transactional
	public PtovtaComissao actualizacion(PtovtaComissao entidad) {
		
		
		PtovtaComissao originalClone = null;
		try {
			originalClone = entidad.getCloneObject();
		} catch (Exception e) {
			log.error("",e);
		}
		
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		
		ptovtaComissaoDAO.actualizacion(entidad);

		logAuditoriaService.auditar(originalClone, entidad, entidad.getEmpresaId()  != null ? entidad.getEmpresaId().getEmpresaId() : null);

		return entidad;

	}

	@Transactional
	public void borrar(PtovtaComissao entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		ptovtaComissaoDAO.actualizacion(entidad);
	}

	public List<PtovtaComissao> buscar(int id) {
		return ptovtaComissaoDAO.buscar(id);
	}

	public List<PtovtaComissao> buscarByPuntaVenta(PuntoVenta puntaVenta) {
		return ptovtaComissaoDAO.buscarByPuntaVenta(puntaVenta);
	}

	@Override
	public PtovtaComissao buscarPuntaVentaEmpresa(Integer puntaVentaId, Integer empresaId) {
		return ptovtaComissaoDAO.buscarPuntaVentaEmpresa(puntaVentaId, empresaId);
	}

}
